local mPhotonView, mJavaBridge = ...

local bigVideo
local materialType

local BANNER_TEMP_INDEX_KEY = "banner_temp_index_key"
local BANNER_TEMP_BANNER_ID_KEY = "banner_temp_banner_id_key"
local MATERIAL_TYPE_VIDEO = 1
local MATERIAL_TYPE_IMAGE = 2

function init()

    mJavaBridge:Log("banner_video", "--init--")
    bigVideo = Rapid:getChild("video_view")
    mJavaBridge:Log("banner_video", "--init end--")
    initData()
    mJavaBridge:Log("banner_video", "--init-done-")
end


------------------播放状态监听begin------------------
IPlayerViewStateChangeListener = {}
function IPlayerViewStateChangeListener.onResume( ... )
    mJavaBridge:Log("banner_video", "--onResume--truef0934k0ibkj")
    return false
end

function IPlayerViewStateChangeListener.onUpdateFinished( ... )
    mJavaBridge:Log("banner_video", "--onUpdateFinished--truef0934k0ibkj")
    return false
end

function IPlayerViewStateChangeListener.onAttachToWindow( ... )
    mJavaBridge:Log("banner_video", "--onAttachToWindow--truef0934k0ibkj")
    
    if bigVideo:getView():canPlayCurrentNetworkEnvironment() then 
        mJavaBridge:postRun(tryContinueOrRestartPlay)
        bigVideo:getView():setAutoPlay(true)
    else
        bigVideo:getView():stop()    
        bigVideo:getView():setAutoPlay(false)    
    end

    return false
end

function IPlayerViewStateChangeListener.onPause( ... )
    mJavaBridge:Log("banner_video", "--onPause--truef0934k0ibkj")
    return false
end

function IPlayerViewStateChangeListener.onStop( ... )
    mJavaBridge:Log("banner_video", "--onStop--truef0934k0ibkj")
    bigVideo:getView():pause(true,2)
    return true
end

function IPlayerViewStateChangeListener.onDetachedFromWindow( ... )
    mJavaBridge:Log("banner_video", "--onDetachedFromWindow--falsef0934k0ibkj")
    --bigVideo:getView():pause(true,3)
    return false
end

function IPlayerViewStateChangeListener.onBackHome(videoView)
    mJavaBridge:Log("banner_video", "--onDetachedFromWindow--truef0934k0ibkj")
    return false
end


function IPlayerViewStateChangeListener.onDestroy(...)
    mJavaBridge:Log("banner_video", "--onDestroy--truef0934k0ibkj")
    return false
end
------------------播放状态监听end--------------------

------------------滑动事件监听begin------------------
IPlayerVisibleAreaRatioChangeListener = {}
function IPlayerVisibleAreaRatioChangeListener.onVisibleAreaRatioChange( inside_ratio )
    mJavaBridge:Log("banner_video", "--onVisibleAreaRatioChange--truef0934k0ibkj:" .. tostring(inside_ratio))
    if(inside_ratio <= 0.3) then
        bigVideo:getView():pause(true,2)
    else 
        bigVideo:getView():tryContinueOrRestartPlay(true);
    end

    return true
end
------------------滑动事件监听end--------------------

function tryContinueOrRestartPlay()
    if materialType == MATERIAL_TYPE_VIDEO then
        bigVideo:getView():tryContinueOrRestartPlay(true);
    end
end

function initData()
    local bannerIndex = tonumber(Rapid:getData(BANNER_TEMP_INDEX_KEY, 1))
    local preBannerId = tostring(Rapid:getData(BANNER_TEMP_BANNER_ID_KEY, ""))
    
    mJavaBridge:Log("banner_video", "--init--" .. bannerIndex .. ", " .. preBannerId)
    local banner_num = tonumber(Rapid:getData('banners_num'))

    if banner_num == 0 then
        changeViewVisibility("container", "gone")
        return
    end
    changeViewVisibility("container", "visible")

    if banner_num == 1 then
        bannerIndex = 1
    end

    
    --再次展示下一个,循环展示

    if banner_num > 1 
    and preBannerId ~= nil 
    and preBannerId ~= "" then 
        bannerIndex = bannerIndex + 1
        mJavaBridge:Log("banner_video", "--next-1-" .. bannerIndex)
    end
    if bannerIndex > banner_num then
        bannerIndex = 1
    end

    --如果bannerid和原来一样，则再次展示下一个，循环展示
    local nowBannerId = Rapid:getData("material_id_" .. bannerIndex)    
    if nowBannerId == preBannerId and banner_num > 1 then 
        bannerIndex = bannerIndex + 1
        mJavaBridge:Log("banner_video", "--next-2-" .. bannerIndex)
    end
    if bannerIndex > banner_num then
        bannerIndex = 1
    end
    
    mJavaBridge:Log("banner_video", "--final--bannerIndex:" .. bannerIndex)

    --素材类型，1为视频，2为图文
    local video_id = Rapid:getData("video_id_" .. bannerIndex)
    if video_id ~= nil and  video_id ~= "" then
        materialType = MATERIAL_TYPE_VIDEO
    else
        materialType = MATERIAL_TYPE_IMAGE
    end
    mJavaBridge:Log("banner_video", "--material_type--:" .. materialType)

    if materialType == MATERIAL_TYPE_VIDEO then
        --视频
        mJavaBridge:Log("banner_video", "--material_type--:is video")
        changeViewVisibility("image_view", "gone")
        changeViewVisibility("video_view", "visible")
        changeViewVisibility("video_mask_all_area", "visible")
        Rapid:setData("vid", Rapid:getData("video_id_" .. bannerIndex))
        Rapid:setData("cover_image_url", Rapid:getData("img_url_" .. bannerIndex))
        Rapid:setData("report_id", "vedio")
        mJavaBridge:Log("banner_video", "--material_type--:333")
        initVideoView()
    else
        --图文
        mJavaBridge:Log("banner_video", "--material_type--:is image")
        changeViewVisibility("image_view", "visible")
        changeViewVisibility("video_view", "gone")
        changeViewVisibility("video_mask_all_area", "gone")
        Rapid:setData("img_url", Rapid:getData("img_url_" .. bannerIndex))
        Rapid:setData("report_id", "image")
        unRegisteVideoView()

    end
    
    
    Rapid:setData("main_title", Rapid:getData("app_title_" .. bannerIndex))
    Rapid:setData("sub_title", Rapid:getData("app_recmd_" .. bannerIndex))

    local score = tostring(Rapid:getData("average_rating_" .. bannerIndex, 0))
    local len = string.len( score )
    if string.sub(score,-3)== "分" then
        score = string.sub(score, 1, len - 3)
    end
    Rapid:setData("average_rating", score)
    Rapid:setData("app_recommendid", Rapid:getData("app_recommendid_" .. bannerIndex))
    Rapid:setData("app_model", Rapid:getData("app_model_" .. bannerIndex))
    Rapid:setData("appid", Rapid:getData("app_id_" .. bannerIndex, ""))
    Rapid:setData("jump_url", Rapid:getData("jump_url_" .. bannerIndex))
    Rapid:setData("material_id", Rapid:getData("material_id_" .. bannerIndex))
    Rapid:setData("report_context_sub_item", Rapid:getData("report_context_" .. bannerIndex))
    Rapid:setData("card_slotid", tostring(Rapid:getData("slotid")) .. "_-1_-1")
    --记录最终的当前banner信息
    Rapid:setData(BANNER_TEMP_INDEX_KEY, bannerIndex)
    Rapid:setData(BANNER_TEMP_BANNER_ID_KEY, Rapid:getData("material_id_" .. bannerIndex))
    mJavaBridge:Log("banner_video", "--end --" .. tostring(Rapid:getData(BANNER_TEMP_BANNER_ID_KEY)))
    --无app信息时，需要隐藏download_button和评分信息
    --评分过低3.6时，需要隐藏评分信息
    decideIfHideAppArea()
    decideIfHideScore()
    --使用完毕后清空内容，防止蹿位
    for i = 1, banner_num do
        Rapid:setData("video_id_" .. i, "")
        Rapid:setData("app_id_" .. i, "")
        Rapid:setData("app_recommendid_" .. i, "")
        Rapid:setData("app_model_" .. i, "")
        Rapid:setData("average_rating_" .. i, "0")
        Rapid:setData("app_title_" .. i, "")
        Rapid:setData("app_recmd_" .. i, "")
        Rapid:setData("report_context_" .. i, "")
    end
end


function initVideoView()
        --非wifi下不自动播放
    if bigVideo:getView():canPlayCurrentNetworkEnvironment() then 
        bigVideo:getView():setAutoPlay(true)
    else
        bigVideo:getView():setAutoPlay(false)
    end
    local state_change_listener = luajava.createProxy("com.tencent.rapidview.deobfuscated.control.video_component.IPlayerViewStateChangeListener", IPlayerViewStateChangeListener)

    local area_ratio_change_listener = luajava.createProxy("com.tencent.rapidview.deobfuscated.control.video_component.IPlayerVisibleAreaRatioChangeListener", IPlayerVisibleAreaRatioChangeListener)
    if (bigVideo ~= nil and state_change_listener ~= nil and area_ratio_change_listener ~= nil) then
        bigVideo:getView():setPlayerViewStateChangeListener(state_change_listener)
        bigVideo:getView():setPlayerVisibleAreaChangeListener(area_ratio_change_listener)
        bigVideo:getView():stop()
    end
end


function unRegisteVideoView()
    --图文模式下不自动播放
    if (bigVideo ~= nil) then
        bigVideo:getView():setPlayerViewStateChangeListener(nil)
        bigVideo:getView():setPlayerVisibleAreaChangeListener(nil)
        bigVideo:getView():stop()
        bigVideo:getView():setAutoPlay(false)
    end
end

function decideIfHideAppArea()
    --如果没有app信息，则隐藏app视图
    local appid = tostring((Rapid:getData("appid")))
    if appid == "" then
        changeViewVisibility("score_text", "gone")
        changeViewVisibility("score_left_img", "gone")
        changeViewVisibility("download_button", "gone")
    else
        changeViewVisibility("score_text", "visible")
        changeViewVisibility("score_left_img", "visible")
        changeViewVisibility("download_button", "visible")
    end
end


function decideIfHideScore()
    --如果评分信息小于3.6，则不展示评分信息

    mJavaBridge:Log("banner_video", "--tonumber--:")
    local score = tonumber(Rapid:getData("average_rating"))
    mJavaBridge:Log("banner_video", "--decideIfHideScore--:" .. score)
    if(score < 3.6) then
        changeViewVisibility("score_text", "gone")
        changeViewVisibility("score_left_img", "gone")
    else
        changeViewVisibility("score_text", "visible")
        changeViewVisibility("score_left_img", "visible")
    end
end

function changeViewVisibility(childViewId, state)
    Rapid:getChild(tostring(childViewId)):setAttr("visibility", tostring(state))
end